package com.tanpu.fund.mapper.generator;

import com.tanpu.fund.entity.generator.FundRateMapping;
import com.tanpu.fund.entity.generator.FundRateMappingExample;
import java.util.List;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

@Mapper
public interface FundRateMappingMapper {
    long countByExample(FundRateMappingExample example);

    int deleteByExample(FundRateMappingExample example);

    /**
     * delete by primary key
     * @param fundId primaryKey
     * @return deleteCount
     */
    int deleteByPrimaryKey(String fundId);

    /**
     * insert record to table
     * @param record the record
     * @return insert count
     */
    int insert(FundRateMapping record);

    int insertOrUpdate(FundRateMapping record);

    int insertOrUpdateSelective(FundRateMapping record);

    int insertOrUpdateWithBLOBs(FundRateMapping record);

    /**
     * insert record to table selective
     * @param record the record
     * @return insert count
     */
    int insertSelective(FundRateMapping record);

    List<FundRateMapping> selectByExampleWithBLOBs(FundRateMappingExample example);

    List<FundRateMapping> selectByExample(FundRateMappingExample example);

    /**
     * select by primary key
     * @param fundId primary key
     * @return object by primary key
     */
    FundRateMapping selectByPrimaryKey(String fundId);

    int updateByExampleSelective(@Param("record") FundRateMapping record, @Param("example") FundRateMappingExample example);

    int updateByExampleWithBLOBs(@Param("record") FundRateMapping record, @Param("example") FundRateMappingExample example);

    int updateByExample(@Param("record") FundRateMapping record, @Param("example") FundRateMappingExample example);

    /**
     * update record selective
     * @param record the updated record
     * @return update count
     */
    int updateByPrimaryKeySelective(FundRateMapping record);

    int updateByPrimaryKeyWithBLOBs(FundRateMapping record);

    /**
     * update record
     * @param record the updated record
     * @return update count
     */
    int updateByPrimaryKey(FundRateMapping record);

    int updateBatch(List<FundRateMapping> list);

    int batchInsert(@Param("list") List<FundRateMapping> list);
}